Bug 215141 - Netbeans on a Retina Macbook is very blurry
Netbeans on a Retina Macbook is very blurry
Status: RESOLVED WONTFIX
Product: platform
Classification: Unclassified
Component: JDK Problems
7.2.1
Macintosh Mac OS X
: P2 with 10 votes (vote)
: 7.2
Assigned To: Jiri Rechtacek
issues@platform
http://bugs.sun.com/bugdatabase/view_...
72patch2-verified jdk_bug_8000629
: RELNOTE
: 219150 219152 220332 224431 232913 234287 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-03 20:15 UTC by Salamander
Modified: 2014-02-03 01:42 UTC (History)
20 users (show)

See Also:
Issue Type: DEFECT
:


Attachments
Comparison of the OS menus (sharp) vs Netbeans text (blurry) (61.23 KB, image/png)
2012-07-03 20:16 UTC, Salamander
Details
Netbeans Mas OS X w/Retina Display (Native Resolution) (1.87 MB, image/png)
2012-07-06 03:48 UTC, velocd
Details
Netbeans w/Retina Support (1.68 MB, image/png)
2012-07-07 06:55 UTC, velocd
Details
Screenshot for Netbeans 7.2 nightly build with JDK 7 update 6. (444.65 KB, image/png)
2012-08-20 02:03 UTC, wordwarrior
Details
Second screenshot for Netbeans 7.2 nightly build with JDK 7 update 6. (498.10 KB, image/png)
2012-08-20 02:04 UTC, wordwarrior
Details
Netbeans on Nightly 201208270001 still fuzzy (767.99 KB, image/png)
2012-08-28 01:16 UTC, likethesky
Details
Netbeans on Nightly 201208270001 still fuzzy--shows version # (975.51 KB, image/png)
2012-08-28 01:17 UTC, likethesky
Details
Screenshot of build 201210090002 on Retina Display (152.69 KB, image/png)
2012-10-09 13:33 UTC, michbarsinai
Details
new build of jdk 1.7 screenshot (288.55 KB, image/png)
2013-06-06 22:58 UTC, athompson
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Salamander 2012-07-03 20:15:50 UTC
Currently the IDE has the same problem that all the other apps do - whatever rendering pipeline the Netbeans UI uses is blurry on a retina macbook pro.  

Product Version = NetBeans IDE 7.1.2 (Build 201205181646)
Operating System = Mac OS X version 10.7.4 running on x86_64
Java; VM; Vendor = 1.7.0_05
Runtime = Java HotSpot(TM) 64-Bit Server VM 23.1-b03
Comment 1 Salamander 2012-07-03 20:16:49 UTC
Created attachment 121708 [details]
Comparison of the OS menus (sharp) vs Netbeans text (blurry)
Comment 2 velocd 2012-07-06 03:48:19 UTC
Created attachment 121780 [details]
Netbeans Mas OS X w/Retina Display (Native Resolution)

Here's another picture showing Netbeans 7.1.2 under Macbook Pro Retina.

Product Version: NetBeans IDE 7.1.2 (Build 201204101705)
Java: 1.7.0_05; Java HotSpot(TM) 64-Bit Server VM 23.1-b03
System: Mac OS X version 10.7.4 running on x86_64; US-ASCII; en_US (nb)
Comment 3 velocd 2012-07-07 06:55:37 UTC
Created attachment 121796 [details]
Netbeans w/Retina Support

Here's the proper workaround to enable retina support w/Netbeans, until formally supported. Though I am using Netbeans 7.2 RC1, I believe this fix should work with 7.1.2 as well.

0. Close Netbeans if open.
1. Enable JRE 1.6.0_33. JDK 1.7.0_05 doesn't work with the following fix.
2. sudo vi /path/to/Netbeans.app/Contents/Info.plist
3. Add the following before </dict></plist> and save:

    <key>NSHighResolutionCapable</key>
    <true/>

4. Logout or restart (to clear App cache).
5. Enjoy non-blurry Netbeans!

Product Version: NetBeans IDE 7.2 RC1 (Build 201206272359)
Java: 1.6.0_33; Java HotSpot(TM) 64-Bit Server VM 20.8-b03-424
System: Mac OS X version 10.7.4 running on x86_64; MacRoman; en_US (nb)
Comment 4 Stanislav Aubrecht 2012-07-18 11:16:53 UTC
Please provide a screen shot of some plain Swing app (e.g. SwingSet demo) and reopen, thanks.
Comment 5 Salamander 2012-07-30 19:45:28 UTC
saubrecht I don't think you understood - it isn't the swing app that is blurry, it is the Netbeans IDE itself.
Comment 6 Stanislav Aubrecht 2012-07-31 08:11:56 UTC
(In reply to comment #5)
> saubrecht I don't think you understood - it isn't the swing app that is blurry,
> it is the Netbeans IDE itself.

You don't understand if a plain Swing app is also blurry then it's a problem in JDK implementation, otherwise it's a NetBeans issue.
Comment 7 Salamander 2012-07-31 16:28:33 UTC
Ok, thank you for the clarification.
I tried as you suggested, and a "normal" swing app launched from within Netbeans is blurry.  I think any java app will be blurry until it is bundled into a mac ".app" file and had the NSHighResolutionCapable flag added.

Side note: After following velocd's instructions it worked great to get Netbeans IDE (latest dev build) to run at high-res.  Wouldn't the fix be as simple as including this key by default in the build?  (With the known issue of that key not working on 1.7, just 1.6 latest).
Comment 8 Jiri Rechtacek 2012-08-02 16:47:57 UTC
http://hg.netbeans.org/core-main/rev/21057cac3f56

Salamander, could you verify the fix in upcoming daily build http://bits.netbeans.org/download/trunk/nightly/latest/ ? A build with this fix should be there in a few days. A notification will come here. Thanks
Comment 9 Quality Engineering 2012-08-03 02:33:16 UTC
Integrated into 'main-golden', will be available in build *201208030001* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/21057cac3f56
User: Jiri Rechtacek <jrechtacek@netbeans.org>
Log: #215141: Netbeans on a Retina Macbook is very blurry
Comment 10 sxsde 2012-08-06 21:06:07 UTC
Doesn't work for me! Still blurry! 

Product Version: NetBeans IDE Dev (Build 201208050001)
Java: 1.6.0_33; Java HotSpot(TM) 64-Bit Server VM 20.8-b03-424
System: Mac OS X version 10.8 running on x86_64; MacRoman; de_DE (nb)
Comment 11 sebastien.schoepfer 2012-08-15 20:43:26 UTC
Hello, i have just install this package : http://www.oracle.com/technetwork/java/javase/downloads/jdk-7-netbeans-download-432126.html 

This is "JDK 7u6 with NetBeans 7.2".

I have the same problem, the NetBeans application is all blurry. I note that JavaFx Scenebuilder, is better but not as beautiful as native application (safari, mail, etc).
Comment 12 Stanislav Aubrecht 2012-08-19 19:27:56 UTC
(In reply to comment #11)
> Hello, i have just install this package :
> http://www.oracle.com/technetwork/java/javase/downloads/jdk-7-netbeans-download-432126.html 
> 
> This is "JDK 7u6 with NetBeans 7.2".
> 
> I have the same problem, the NetBeans application is all blurry. I note that
> JavaFx Scenebuilder, is better but not as beautiful as native application
> (safari, mail, etc).

The problem was (hopefully) fixed in a development build, use the link above to get the latest nightly build and check if the problem was fixed for you.
Comment 13 Stanislav Aubrecht 2012-08-19 19:28:42 UTC
(In reply to comment #10)
> Doesn't work for me! Still blurry! 
> 
> Product Version: NetBeans IDE Dev (Build 201208050001)
> Java: 1.6.0_33; Java HotSpot(TM) 64-Bit Server VM 20.8-b03-424
> System: Mac OS X version 10.8 running on x86_64; MacRoman; de_DE (nb)

Try running with JDK 7, update 6 and reopen if the problem is still reproducible, thanks.
Comment 14 wordwarrior 2012-08-20 02:03:49 UTC
Created attachment 123294 [details]
Screenshot for Netbeans 7.2 nightly build with JDK 7 update 6.

Screenshot for Netbeans 7.2 nightly build with JDK 7 update 6.
Comment 15 wordwarrior 2012-08-20 02:04:32 UTC
Created attachment 123295 [details]
Second screenshot for Netbeans 7.2 nightly build with JDK 7 update 6.

Second screenshot for Netbeans 7.2 nightly build with JDK 7 update 6.
Comment 16 wordwarrior 2012-08-20 02:05:25 UTC
Still fuzzy for me.  This is what I'm running:

Product Version: NetBeans IDE 7.2 (Build 201207171143)
Java: 1.7.0_06; Java HotSpot(TM) 64-Bit Server VM 23.2-b09
System: Mac OS X version 10.8 running on x86_64; US-ASCII; en_US (nb)
User directory: /Users/luke/Library/Application Support/NetBeans/7.2
Cache directory: /Users/luke/Library/Caches/NetBeans/7.2
Comment 17 Stanislav Aubrecht 2012-08-20 07:55:08 UTC
(In reply to comment #16)
> Still fuzzy for me.  This is what I'm running:
> 
> Product Version: NetBeans IDE 7.2 (Build 201207171143)
> Java: 1.7.0_06; Java HotSpot(TM) 64-Bit Server VM 23.2-b09
> System: Mac OS X version 10.8 running on x86_64; US-ASCII; en_US (nb)
> User directory: /Users/luke/Library/Application Support/NetBeans/7.2
> Cache directory: /Users/luke/Library/Caches/NetBeans/7.2

Did you use the ZIP or Mac installer? Please note the will take effect only when using Mac installer...
Comment 18 sebastien.schoepfer 2012-08-21 22:40:36 UTC
Thank you "saubrecht" it 's work with the last nighlty build. But it uses java 1.6, when will it work with java 1.7 ??
Comment 19 wordwarrior 2012-08-22 00:07:22 UTC
This is the only Mac OS X installer file that I found on the provided link:

 jdk-7u6-nb-7_2-macosx-x64-ml.dmg

It contains an mpkg, as opposed to a pkg, although it's definitely not a zip.

http://www.oracle.com/technetwork/java/javase/downloads/jdk-7-netbeans-download-432126.html

Do I have the right installer?
Comment 20 Tomas Danek 2012-08-27 13:14:20 UTC
definitely not for patch1, since patch1 won't have installers.
Comment 21 likethesky 2012-08-28 01:16:08 UTC
Created attachment 123632 [details]
Netbeans on Nightly 201208270001 still fuzzy
Comment 22 likethesky 2012-08-28 01:17:22 UTC
Created attachment 123633 [details]
Netbeans on Nightly 201208270001 still fuzzy--shows version #
Comment 23 likethesky 2012-08-28 01:17:49 UTC
So I just downloaded the nightly today (201208270001) and the problem still exists.

I downloaded from: http://bits.netbeans.org/dev/nightly/

Which gave me a .dmg containing an .mpkg of course.

Attached are two screen shots showing the issue--they are in the above two posts.
Comment 24 likethesky 2012-08-28 01:23:43 UTC
A bit more info, just to be crystal clear:

I downloaded the SE version (far left button).

It gave me this file: netbeans-trunk-nightly-201208270001-javase-macosx.dmg

When mounted, it produced this file:

NetBeans Dev 201208270001.mpkg

Which I double-clicked and installed.
Comment 25 djwood 2012-08-31 05:34:17 UTC
Hi saubrecht-

Thanks for looking into this bug.  I tried standard 7.2 with Info.plist mod on JDK 1.7.0_06 (build 23.2-b09) and it ran but still blurry, but I can live with it - still getting used to higer resolution.  In the mean time I'll be eagerly awaiting the 7.2.1 patch...
Comment 26 wordwarrior 2012-09-02 15:06:12 UTC
I'm running Java 7 update 8 on a Retina MacBook Pro, and the Java Control Panel (which I assume is in Swing) is blurry as well.

System Preferences > Java.
Comment 27 Jiri Rechtacek 2012-10-01 09:03:43 UTC
*** Bug 219152 has been marked as a duplicate of this bug. ***
Comment 28 idaderko 2012-10-04 17:30:23 UTC
I have just purchased Retina MacBook and Downloaded latest version of NetBeans (7.2), it is my favourite java working environment and it is very frustrating to work with it now as everything is very blurry.

Is there any chance we will get a retina support in soon future, that would be really nice.
Comment 29 Jiri Rechtacek 2012-10-05 05:43:49 UTC
(In reply to comment #28)
> I have just purchased Retina MacBook and Downloaded latest version of NetBeans
> (7.2), it is my favourite java working environment and it is very frustrating
> to work with it now as everything is very blurry.
> 
> Is there any chance we will get a retina support in soon future, that would be
> really nice.

Could you create new sample in NetBeans IDE (e.g. Create New Project|Samples|GUI Form Examples) and run it from IDE? Then take a screen shot and attach it here. Thanks
Comment 30 Jiri Rechtacek 2012-10-05 07:06:53 UTC
(In reply to comment #29)
> (In reply to comment #28)
> > I have just purchased Retina MacBook and Downloaded latest version of NetBeans
> > (7.2), it is my favourite java working environment and it is very frustrating
> > to work with it now as everything is very blurry.
> > 
> > Is there any chance we will get a retina support in soon future, that would be
> > really nice.
> 
> Could you create new sample in NetBeans IDE (e.g. Create New
> Project|Samples|GUI Form Examples) and run it from IDE? Then take a screen shot
> and attach it here. Thanks

Also please attach what java version are you using.
$ java -version
Comment 31 Stanislav Aubrecht 2012-10-08 09:07:24 UTC
It's a JDK problem since plain Swing application are blurry as well.
Without a Retina MacBook to reproduce the problem we can't even try any fix...
Comment 32 Jiri Rechtacek 2012-10-08 14:45:33 UTC
JDK/NB bundles doesn't contain the suggested flag:
<key>NSHighResolutionCapable</key> 
<true/>

I'm going to fix it ASAP.
Comment 33 Jiri Rechtacek 2012-10-08 15:34:58 UTC
core-main/rev/da842a54911d adds the flag to all instances of Info.plist
Comment 34 Quality Engineering 2012-10-09 02:03:55 UTC
Integrated into 'main-golden', will be available in build *201210090002* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/da842a54911d
User: Jiri Rechtacek <jrechtacek@netbeans.org>
Log: #215141: hotfix - Netbeans on a Retina Macbook is very blurry
Comment 35 Jiri Rechtacek 2012-10-09 06:56:08 UTC
(In reply to comment #34)
> Integrated into 'main-golden', will be available in build *201210090002* on
> http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
> Changeset: http://hg.netbeans.org/main-golden/rev/da842a54911d
> User: Jiri Rechtacek <jrechtacek@netbeans.org>
> Log: #215141: hotfix - Netbeans on a Retina Macbook is very blurry

Could anyone who runs the NetBeans IDE on Retina Macbook to check whether the fix helped in the latest nightly build [*]? Let to know ASAP to meet the backport to NB7.2.1 Thanks a lot.
[*] http://bits.netbeans.org/download/trunk/nightly/latest/
Comment 36 michbarsinai 2012-10-09 13:33:31 UTC
Created attachment 125630 [details]
Screenshot of build 201210090002 on Retina Display

Image still blurry, on jdk1.7.0_06. Note the difference between the window title + the menus and the code.
Comment 37 Antonin Nebuzelsky 2012-10-09 14:18:16 UTC
(In reply to comment #36)
> Created attachment 125630 [details]
> Screenshot of build 201210090002 on Retina Display
> 
> Image still blurry, on jdk1.7.0_06. Note the difference between the window
> title + the menus and the code.

michbarsinai, did you install the build using DMG, or only ran from an unzipped NB build? Thanks.
Comment 38 michbarsinai 2012-10-09 14:24:27 UTC
From the DMG downloaded from http://bits.netbeans.org/download/trunk/nightly/latest/, using the Java SE download.

JDK 1.7.0_06
Mac OSX 10.8.2
Comment 39 Antonin Nebuzelsky 2012-10-09 15:05:46 UTC
michbarsinai, can you please try this same NB build also with the latest Apple's JDK 6? Thanks.
Comment 40 michbarsinai 2012-10-09 15:21:14 UTC
On JDK it's working fine (hi-res supported).
Comment 41 michbarsinai 2012-10-09 15:34:42 UTC
Oops. Sorry. JDK version is:

$ /System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home/bin/java -version
java version "1.6.0_35"
Java(TM) SE Runtime Environment (build 1.6.0_35-b10-428-11M3811)
Java HotSpot(TM) 64-Bit Server VM (build 20.10-b01-428, mixed mode)
Comment 42 Antonin Nebuzelsky 2012-10-09 15:40:06 UTC
(In reply to comment #40)
> On JDK 6 it's working fine (hi-res supported).

Thanks for confirmation. Marking verified fixed for JDK 6. Now the changeset should be backported to 7.2.1.

For the Java 7 case I am filing an additional issue to JDK team - #JDK-8000629.

Ken, we should add a note to release notes of 7.2.1 that with Retina display you may encounter a blurry rendering of NetBeans with Java 7 and switching to Java 6 is the workaround. Thanks.
Comment 43 Kenneth Ganfield 2012-10-09 16:33:26 UTC
Added to release notes
Comment 44 Jiri Rechtacek 2012-10-09 17:18:32 UTC
http://hg.netbeans.org/releases/rev/e35f7bbf8f3f
Comment 45 Quality Engineering 2012-10-10 14:15:58 UTC
Integrated into 'releases', will be available in build *201210100934* or newer. Wait for official and publicly available build.
Changeset: http://hg.netbeans.org/releases/rev/e35f7bbf8f3f
User: Jiri Rechtacek <jrechtacek@netbeans.org>
Log: #215141: hotfix - Netbeans on a Retina Macbook is very blurry
(transplanted from da842a54911daf35cfd9a728c13af3509041bb0c)
Comment 46 Tomas Danek 2012-10-11 12:35:21 UTC
backported correctly, Info.plist of installed IDE contains 

<key>NSHighResolutionCapable</key>
<true/>

tags.
Comment 47 Salamander 2012-10-21 18:42:57 UTC
#$%^@#.

I just installed the latest java updates for OSX Mountain Lion, and for whatever reason, the fix stopped working!  I at the same time downloaded fresh builds of Netbeans (7.3 beta and latest Dev), so hard to pinpoint what happened when.

Under the new Java Control Panel, it only shows the 1.7 JRE, but that could be because the 1.6 is disabled for all browsers.  **Unknown if this change is related.**

I tried setting the java home to 1.6 in the netbeans.conf file as per http://wiki.netbeans.org/JDKVersionAndMacOS
... but that didn't seem to take.  

I launched it from the command line forcing the runtime to 1.6, ***and that worked***  But it is a bit of a pain to launch from the command line every time, I'd much rather find out why it stopped using the netbeans.conf setting.

From icon launch with modified netbeans.conf:
Product Version: NetBeans IDE Dev (Build 201210160002)
Java: 1.7.0_07; Java HotSpot(TM) 64-Bit Server VM 23.3-b01

From command line launch:
Product Version: NetBeans IDE Dev (Build 201210160002)
Java: 1.6.0_37; Java HotSpot(TM) 64-Bit Server VM 20.12-b01-434
Comment 48 ender01 2012-10-24 12:32:49 UTC
Salamander@netbeans.org 

I just had the same thing happen, and using the 20121012 dev build I was able to change the property in netbeans.conf and it 'fixed' the issue for now.  The value I have is:

netbeans_jdkhome="/System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home"

Of course, a real fix would be do not to need Apples JDK but I have not found anything promising that that will happen anytime soon.  :(
Comment 49 Salamander 2012-10-24 16:52:46 UTC
Whoops.  Forgot to remove the # at the beginning of the line.
Both my path and your path works.
yay not having to run from a command line.

Boo having to manually force NB to run with the old JRE.

What's the deal, 1.7 doesn't have a similar flag?
Comment 50 Jiri Rechtacek 2012-10-25 14:31:30 UTC
(In reply to comment #47)
> #$%^@#.
> 
> I just installed the latest java updates for OSX Mountain Lion, and for
> whatever reason, the fix stopped working!  I at the same time downloaded fresh
> builds of Netbeans (7.3 beta and latest Dev), so hard to pinpoint what happened
> when.
Caused by Java Update itself - there is a F&Q how to setup the JDK Home in IDE on the Java 6 thus the fix should work again.
http://wiki.netbeans.org/FaqMacJdkHome

(In reply to comment #49)
> Boo having to manually force NB to run with the old JRE.
> 
> What's the deal, 1.7 doesn't have a similar flag?
The problem was reported to JDK team. You can follow it on http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=8000629
Comment 51 Salamander 2012-10-25 16:26:49 UTC
Great info, I will follow that bug.  Thank you!
Comment 52 Antonin Nebuzelsky 2012-11-01 08:54:52 UTC
*** Bug 220332 has been marked as a duplicate of this bug. ***
Comment 53 Antonin Nebuzelsky 2012-11-01 09:08:23 UTC
Just to sum up as more reports are coming:

The problem is fixed in NetBeans 7.2.1 and 7.3 dev when running with JDK 6.

The problem still exists when running any version of NetBeans on JDK 7. The following bug is tracking progress on fixing this problem with JDK 7:
http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=8000629
Comment 54 efreetcs 2012-12-01 17:51:56 UTC
Hi,

I try all your fixes on my macbook pro retina (installing JDK 1.6 and Netbeans 7.2.1), and all is fine. But... On MAC OSX only !

I have a windows 8 bootcamp installation.
I do the same things (JDK 1.6, netbeans), but, under windows 8, the UI stays blurry.

I tried the info.plist and adding the hires tips, but the UI is always blurry.
Comment 55 Jiri Rechtacek 2012-12-01 19:00:11 UTC
(In reply to comment #54)
> Hi,
> 
> I try all your fixes on my macbook pro retina (installing JDK 1.6 and Netbeans
> 7.2.1), and all is fine. But... On MAC OSX only !
> 
> I have a windows 8 bootcamp installation.
> I do the same things (JDK 1.6, netbeans), but, under windows 8, the UI stays
> blurry.
> 
> I tried the info.plist and adding the hires tips, but the UI is always blurry.

efreetcs, report an new issue instead of reopening unrelated Mac issue. Thanks
Comment 56 Miloslav Metelka 2012-12-04 14:52:27 UTC
*** Bug 219150 has been marked as a duplicate of this bug. ***
Comment 57 coops 2012-12-10 05:46:22 UTC
The fact that you fail to support high resolution displays has nothing to do with platform. This is a multi-platform issue and is also encountered when using Windows with bootcamp on a Retina display. I'm setting "Platform" to All and reopening this ticket. The title just mentions "Retina Macbook", that the OP is using OS X is coincidental. When you have fixed this on ALL platforms you can close this ticket IMO...
Comment 58 Stanislav Aubrecht 2012-12-10 09:07:23 UTC
(In reply to comment #57)
> The fact that you fail to support high resolution displays has nothing to do
> with platform. This is a multi-platform issue and is also encountered when
> using Windows with bootcamp on a Retina display. I'm setting "Platform" to All
> and reopening this ticket. The title just mentions "Retina Macbook", that the
> OP is using OS X is coincidental. When you have fixed this on ALL platforms you
> can close this ticket IMO...

The problem with non-standard DPI displays on MS Windows has been fixed in issue http://netbeans.org/bugzilla/show_bug.cgi?id=221303
Do not reopen this issue unless you can reproduce it on Mac OS X.
Comment 59 Lone_Wolf236 2012-12-11 14:32:45 UTC
Actually the issue was never fixed for me...
i'm using Netbeans 7.2.1. on OSX 10.8.2

Please tell me if i can help!
Comment 60 Stanislav Aubrecht 2012-12-12 09:38:17 UTC
(In reply to comment #59)
> Actually the issue was never fixed for me...
> i'm using Netbeans 7.2.1. on OSX 10.8.2
> 
> Please tell me if i can help!

Did you install NetBeans 7.2.1 from scratch or did you just update from 7.2?
Comment 61 Lone_Wolf236 2012-12-12 15:36:11 UTC
i tried both, with the same result
Comment 62 wordwarrior 2012-12-15 00:25:03 UTC
This is definitely a bug with Swing/AWT JDK 7 and not a Netbeans problem.

There's no way to vote or comment on the following bug:

http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=8000629#

The account I set up on the Oracle site doesn't give me anything other than read access.  Apparently, others are having this problem as well.

http://www.java.net/forum/topic/jdk/java-se-snapshots-project-feedback/bug-database-read-only

I'm try running both the lambda early edition and the regular JDK 8 and I still see blurriness. 

However, setting the JDK to Java 6 resolves the blurriness.

Is there any way for us to comment on or at least vote on the bugs.sun.com bug?  I'm concerned that this might not be fixed in time for JDK 8 and that would be really bad.
Comment 63 Jiri Rechtacek 2012-12-17 08:56:18 UTC
(In reply to comment #62)
> This is definitely a bug with Swing/AWT JDK 7 and not a Netbeans problem.
Right, that's the reason why it's not open in the NetBeans issue tracking system.

> However, setting the JDK to Java 6 resolves the blurriness.
With (Apple's) Java 6 and with the switch [*] in NetBeans IDE it works.

[*]
<key>NSHighResolutionCapable</key>
<true/>
in Info.plist of installed IDE
Comment 64 Stanislav Aubrecht 2013-01-07 09:49:54 UTC
*** Bug 224431 has been marked as a duplicate of this bug. ***
Comment 65 slavikme 2013-01-07 19:22:59 UTC
To set a default JDK version for netbeans on Mac OS X, follow these steps:

1. Open any editor.
2. Press CMD+O (to open the "Open Dialog Windows")
3. in the opened window press CMD+SHIFT+G (to enter the path manually)
4. Type
"/Applications/NetBeans/NetBeans 7.3 Beta 2.app/Contents/Resources/NetBeans/etc/netbeans.conf"
or "/Applications/NetBeans/NetBeans 7.3 Beta 1.app/Contents/Resources/NetBeans/etc/netbeans.conf"
or "/Applications/NetBeans/NetBeans 7.2.1.app/Contents/Resources/NetBeans/etc/netbeans.conf"
or "/Applications/NetBeans/NetBeans 7.2.app/Contents/Resources/NetBeans/etc/netbeans.conf"
or whatever version of NetBeans you've got, and press ENTER (or click on "Go" button)
5. Press ENTER again (or click on "Open" button)
6. In the netbeans.conf file, search the line that looks like this: 
#netbeans_jdkhome="/path/to/jdk"
7. Under this line add:
netbeans_jdkhome="/System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home"
8. Press CMD+S ()to save the document.

Now you can open (or reopen) the NetBeans.
Comment 66 LuCiAn0 2013-02-25 15:49:32 UTC
Java 6 cannot be downloaded directly from oracle website. Apple provides it under their developer page: https://developer.apple.com/downloads/index.action

It's named: Java for OS X 2013-001 Developer Package

Once you have jdk 6 in place then just follow steps at comment #65.

Ahhh how good is to have my fonts looking great again.
Comment 67 ota 2013-03-05 10:34:23 UTC
I just updated netbeans to 7.3 and java to 1.7.0.17
The problem still persists. Please reopen the issue.

Also see http://netbeans.org/bugzilla/show_bug.cgi?id=216655
Comment 68 Jiri Rechtacek 2013-03-05 13:20:32 UTC
(In reply to comment #67)
> I just updated netbeans to 7.3 and java to 1.7.0.17
It's a JDK Bug - #8000629 not bug in NetBeans IDE. Follow #8000629 bug to know its status. Now the fix is still in progress.
http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=8000629

Closing as WONTFIX, the NetBeans team will not fix it in NetBeans sources.

> The problem still persists. Please reopen the issue.
Don't reopen the bug on Java 7 as long as the fix will be delivered in some Java Update.

As a workaround run IDE on Java 6 - http://wiki.netbeans.org/FaqMacJdkHome
Comment 69 ota 2013-03-06 08:30:45 UTC
So why do other editors (e.g. eclipse) running on JDK7 dont have the same
rendering issues as netbeans?
Comment 70 Miloslav Metelka 2013-03-06 13:32:44 UTC
(In reply to comment #69)
> So why do other editors (e.g. eclipse) running on JDK7 dont have the same
> rendering issues as netbeans?

Eclipse uses SWT for rendering while NB uses Swing (over AWT) which is completely different.
Comment 71 indorock 2013-03-08 15:29:37 UTC
Comment #65 totally did the trick. Make sure you get the "older" version of JDK to point NetBeans to. 
The inferface icons still look like crap, but at least I'm productive again.
Comment 72 jsonx 2013-04-02 01:02:38 UTC
I am a new Mac user. I tried to all downgrade methods from Java 1.7 to 1.6 but couldn't make it. 

I just removed the Java folder completely from the Library folder. Than I downloaded and installed the Java 1.6 (see comment 66, thanks to LuCiAn0) Than I installed the Netbeans 7.3 again and everything works good (icons, texts, etc.).
Comment 73 Salamander 2013-04-15 21:48:56 UTC
Anything we can do to (+1) the bug with Oracle/Apple/etc?  As retina becomes the norm and java 1.6 reaches end of life in 2013, this could really hamper Netbeans adoption among the mac developer crowd.
Comment 74 Salamander 2013-04-15 22:26:07 UTC
I could have sworn I had it in retina (non-fuzzy) mode while compiling 1.7 java projects.
I just upgraded to jdk1.7.0_17 and moved over the settings.

And now I can't have both "non-fuzzy" and "able to compile against 1.7 runtime" at the same time.  And can't even get the DEV version to launch with this fix any more.

=========
CURRENT SETTINGS, ALL OF WHICH LOOK GOOD:

JDKs:
/Library/Java/JavaVirtualMachines/jdk1.7.0_17.jdk/Contents/Home
and
/System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home

whereis java
/usr/bin/java

echo $JAVA_HOME
/Library/Java/JavaVirtualMachines/jdk1.7.0_17.jdk/Contents/Home

ls -la /usr/bin/java
lrwxr-xr-x  1 root  wheel    74B Mar  4 20:45 /usr/bin/java@ -> /System/Library/Frameworks/JavaVM.framework/Versions/Current/Commands/java

Verified that my Netbeans Info.plist (both 7.3 and nightly) have
<key>NSHighResolutionCapable</key> <true/>

/System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home/bin/java -version
java version "1.6.0_43"
=======

Which results in the blurry app.
NOW, if I move over the 
netbeans_jdkhome="/System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home"
in 7.3, it won't let me compile for 1.7 any more.

And if I try it in the DEV version, it won't even start, and gives a "Cannot run on older version than 1.7" message. 

So, is this fix/workaround now broken?
Comment 75 athompson 2013-04-15 22:59:59 UTC
(In reply to comment #74)
> So, is this fix/workaround now broken?

The reason that this issue was resolved as "wontfix" is because it is *not* a problem with Netbeans, but rather a problem with the Oracle's JRE. Any app that does not supply its own native widget library has the same problem. See [1][this Oracle bug] for details.

[1]: http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=8000629
Comment 76 Salamander 2013-04-15 23:03:11 UTC
Yes, I understand that.

BUT - there used to be a workaround, where if you manually edited the netbeans_jdkhome to be 1.6, you could get the best of both worlds: non-blurry, and able to compile 1.7 code.

Now it seems like the workaround broke?  Even if it isn't Netbean's fault that the workaround is now broken, I'd like to confirm if that is true.
Comment 77 Salamander 2013-04-15 23:12:41 UTC
Ah-ha.  Workaround did NOT break.
(But the JDK updater would like you to think that it did by changing the defaults)

If you go into 
"Java Platform Manager" in Netbeans.
And select your "JDK 1.7" platform.
double check that the actual "platform classpath" entries list v 7 instead of v 6 items.

I had to manually remove the 17 platform, re-create it, and specify the full path to 1.7
/Library/Java/JavaVirtualMachines/jdk1.7.0_17.jdk/Contents/Home

Hopefully this helps some other JDK updaters out there.


Note: this workaround is working in 7.3, but doesn't work in DEV, so I'm guessing that we are SOL unless someone fixes the bug @athompson speaks of.  :(
Comment 78 athompson 2013-04-15 23:18:17 UTC
The workaround was to use Apple's JDK 6 to run Netbeans in the mean time. You can still do so with the 7.3 release, but the daily builds migrated to JDK 7 to take advantage of its new features.

I don't like it either. I actually opened a bug requesting that the migration be delayed until the retina issue was fixed (issue #228003), but then I realized/was convinced that it was better to not delay the progress of Netbeans in the mean time. So now I use a blurry dev build.
Comment 79 Antonin Nebuzelsky 2013-04-16 12:35:08 UTC
(In reply to comment #78)
> So now I use a blurry dev build.

A part of the Java fix, related to fonts rendering, should appear in jdk8 b86, as mentioned in the JDK bug comments. That build is not available yet, but could you please try it and report back as soon as it appears here?:
http://jdk8.java.net/download.html
Comment 80 coops 2013-04-19 16:49:26 UTC
This is fixed for me now! Could finally upgrade to Netbeans 7.3.
Comment 81 athompson 2013-04-20 15:59:58 UTC
The fixed did not make it into build 86. I'll try the next one.
Comment 82 athompson 2013-05-09 16:52:22 UTC
Oooh! So pretty with JDK 8 build 88! You have to get the 9 May daily build of Netbeans or newer though or it won't start.
Comment 83 athompson 2013-05-09 16:53:13 UTC
That is, the 8 May daily build of Netbeans.
Comment 84 thomoo 2013-05-12 12:34:32 UTC
FYI... I was having the same issue. I needed to run jdk 1.7, but force netbeans 7.3 to use jdk 1.6.

My workaround was to set 

netbeans_jdkhome="/System/Library/Frameworks/JavaVM.framework/Versions/1.6/Home"

in 

/Applications/NetBeans/NetBeans 7.3.app/Contents/Resources/NetBeans/etc/netbeans.conf

This forces the IDE to use 1.6, but I can also choose 1.7 under Tools > Java Platforms.

Hope this helps!
Comment 85 Antonin Nebuzelsky 2013-06-06 10:25:46 UTC
Can you please test also with b28 promoted build of 7u40, as soon as it becomes available at https://jdk7.java.net/download.html ?

Is everything fine on Retina now? Do you see any remaining rendering problems?

Can someone please attach a screenshot running NetBeans with 7u40b28 on Retina?

Thanks.
Comment 86 athompson 2013-06-06 22:55:26 UTC
(In reply to comment #85)
> Can you please test also with b28 promoted build of 7u40, as soon as it becomes
> available at https://jdk7.java.net/download.html ?

Looks good.
Comment 87 athompson 2013-06-06 22:58:07 UTC
Created attachment 135472 [details]
new build of jdk 1.7 screenshot
Comment 88 markedwards 2013-06-25 02:04:40 UTC
I can also confirm that rendering is fixed using b29 of 7u40.

I would also note, however, that performance is absolutely awful when using this build on a retina-display, compared to the Apple-supplied Java 6 running on the same display.  Using the 7u40 build on a non-retina secondary display, performance is fine, its just problematic when moving the Netbeans window to the retina display.

This may be because of the early build, but if performance stays at this level it will be unusable.
Comment 89 markiewb 2013-06-25 20:06:54 UTC
FYI There is an interesting blog post about the internals http://bulenkov.com/2013/06/23/retina-support-in-oracle-jdk-1-7/
Comment 90 Stanislav Aubrecht 2013-07-29 14:05:08 UTC
*** Bug 232913 has been marked as a duplicate of this bug. ***
Comment 91 levani 2013-08-05 12:33:05 UTC
Is anyone working on this bug? Netbeans suddenly made completely useless on my mac because it's so blurry I can hardly even read the code. This happened after updating jdk version from 1.6 to 1.7.0_25. I use netbeans 7.3.1 (the same situation on 7.4 beta), and osx 10.8.4. Please someone fix this, I don't want to switch my favorite editor! Here is the screenshot, I don't know how it appears on normal screen but it's looks terrible on retina display:

http://img839.imageshack.us/img839/177/xol.png
Comment 92 Antonin Nebuzelsky 2013-08-05 12:39:44 UTC
(In reply to comment #91)
> Is anyone working on this bug?

As mentioned above, the rendering on Retina is fixed in early access builds of JDK 8 and JDK 7u40.

http://jdk8.java.net/download.html
http://jdk7.java.net/download.html
Comment 93 Salamander 2013-08-05 19:54:49 UTC
@markedwards what part of the performance is bad?  I just flopped over from the old 1.6 to 1.7u40, and while scrolling isn't super smooth (and I see my CPU spike a bit when I scroll a lot) it isn't all that bad.
Comment 94 Salamander 2013-08-06 19:58:03 UTC
I take it back.  Yes, that is ugly and slower in 7u40.
Scrolling is choppy.
The folder "expand" arrows on the left are blurry.

Big issue with the post-java-6 usage of Netbeans, IMHO.
Comment 95 Jiri Rechtacek 2013-08-13 06:29:28 UTC
*** Bug 234287 has been marked as a duplicate of this bug. ***
Comment 96 markedwards 2013-10-28 17:31:30 UTC
I filed a separate bug for the performance issues noted in this thread, associated with running Netbeans on a retina display with Java 7.

https://netbeans.org/bugzilla/show_bug.cgi?id=237724
Comment 97 germanfred 2013-11-26 10:36:46 UTC
I can confirm this bug exists in JDK 7u45.

MY FIX: Upgrading to the latest build JDK 8b117 resolves the support of the retina display. Netbeans is nice and crisp and clear again :)
Comment 98 AlexaGerancho 2014-02-03 01:42:23 UTC
*** Bug 260998 has been marked as a duplicate of this bug. ***
Seen live from the domain http://volichat.com/adult-chat-rooms
Marked for reference. Resolved as fixed @bugzilla.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo